// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "parser.hh"


// Unqualified %code blocks.
#line 113 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"

   #include "parser/ParserDriver.h"
   #define YY_DECL yy::parser::symbol_type yylex(souffle::ParserDriver& driver, yyscan_t yyscanner)
   YY_DECL;

#line 52 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 144 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"

  /// Build a parser object.
  parser::parser (ParserDriver &driver_yyarg, yyscan_t yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.YY_MOVE_OR_COPY< AggregateOp > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg: // arg
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_atom: // atom
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
      case symbol_kind::S_functor_attribute: // functor_attribute
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_adt_branch: // adt_branch
        value.YY_MOVE_OR_COPY< Mov<Own<ast::BranchType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fact: // fact
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component_decl: // component_decl
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Component>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component_init: // component_init
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ComponentInit>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component_type: // component_type
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ComponentType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Constraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_plan_order: // plan_order
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ExecutionOrder>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_query_plan: // query_plan
      case symbol_kind::S_query_plan_list: // query_plan_list
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ExecutionPlan>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_dependency: // dependency
        value.YY_MOVE_OR_COPY< Mov<Own<ast::FunctionalConstraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.YY_MOVE_OR_COPY< Mov<Own<ast::FunctorDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Pragma>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_type_decl: // type_decl
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Type>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.YY_MOVE_OR_COPY< Mov<RuleBody> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_head: // head
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_adt_branch_list: // adt_branch_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::BranchType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Directive>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_dependency_list_aux: // dependency_list_aux
      case symbol_kind::S_dependency_list: // dependency_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::FunctionalConstraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_relation_names: // relation_names
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Relation>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_plan_order_list: // non_empty_plan_order_list
        value.YY_MOVE_OR_COPY< Mov<ast::ExecutionOrder::ExecOrder> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qualified_name: // qualified_name
        value.YY_MOVE_OR_COPY< Mov<ast::QualifiedName> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.YY_MOVE_OR_COPY< Mov<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_component_type_params: // component_type_params
      case symbol_kind::S_component_param_list: // component_param_list
        value.YY_MOVE_OR_COPY< Mov<std::vector<ast::QualifiedName>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.YY_MOVE_OR_COPY< Mov<std::vector<std::pair
            <std::string, std::string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_attribute_names: // non_empty_attribute_names
        value.YY_MOVE_OR_COPY< Mov<std::vector<std::string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.YY_MOVE_OR_COPY< ast::DirectiveType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.YY_MOVE_OR_COPY< std::set<RelationTag> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.move< AggregateOp > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg: // arg
        value.move< Mov<Own<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_atom: // atom
        value.move< Mov<Own<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
      case symbol_kind::S_functor_attribute: // functor_attribute
        value.move< Mov<Own<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_adt_branch: // adt_branch
        value.move< Mov<Own<ast::BranchType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fact: // fact
        value.move< Mov<Own<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component_decl: // component_decl
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.move< Mov<Own<ast::Component>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component_init: // component_init
        value.move< Mov<Own<ast::ComponentInit>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component_type: // component_type
        value.move< Mov<Own<ast::ComponentType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.move< Mov<Own<ast::Constraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_plan_order: // plan_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_query_plan: // query_plan
      case symbol_kind::S_query_plan_list: // query_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_dependency: // dependency
        value.move< Mov<Own<ast::FunctionalConstraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.move< Mov<Own<ast::Pragma>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_type_decl: // type_decl
        value.move< Mov<Own<ast::Type>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.move< Mov<RuleBody> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_head: // head
        value.move< Mov<VecOwn<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.move< Mov<VecOwn<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_adt_branch_list: // adt_branch_list
        value.move< Mov<VecOwn<ast::BranchType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_dependency_list_aux: // dependency_list_aux
      case symbol_kind::S_dependency_list: // dependency_list
        value.move< Mov<VecOwn<ast::FunctionalConstraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_relation_names: // relation_names
        value.move< Mov<VecOwn<ast::Relation>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_plan_order_list: // non_empty_plan_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qualified_name: // qualified_name
        value.move< Mov<ast::QualifiedName> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.move< Mov<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_component_type_params: // component_type_params
      case symbol_kind::S_component_param_list: // component_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_attribute_names: // non_empty_attribute_names
        value.move< Mov<std::vector<std::string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.move< ast::DirectiveType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.move< std::set<RelationTag> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.copy< AggregateOp > (that.value);
        break;

      case symbol_kind::S_arg: // arg
        value.copy< Mov<Own<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_atom: // atom
        value.copy< Mov<Own<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
      case symbol_kind::S_functor_attribute: // functor_attribute
        value.copy< Mov<Own<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_adt_branch: // adt_branch
        value.copy< Mov<Own<ast::BranchType>> > (that.value);
        break;

      case symbol_kind::S_fact: // fact
        value.copy< Mov<Own<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_component_decl: // component_decl
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.copy< Mov<Own<ast::Component>> > (that.value);
        break;

      case symbol_kind::S_component_init: // component_init
        value.copy< Mov<Own<ast::ComponentInit>> > (that.value);
        break;

      case symbol_kind::S_component_type: // component_type
        value.copy< Mov<Own<ast::ComponentType>> > (that.value);
        break;

      case symbol_kind::S_constraint: // constraint
        value.copy< Mov<Own<ast::Constraint>> > (that.value);
        break;

      case symbol_kind::S_plan_order: // plan_order
        value.copy< Mov<Own<ast::ExecutionOrder>> > (that.value);
        break;

      case symbol_kind::S_query_plan: // query_plan
      case symbol_kind::S_query_plan_list: // query_plan_list
        value.copy< Mov<Own<ast::ExecutionPlan>> > (that.value);
        break;

      case symbol_kind::S_dependency: // dependency
        value.copy< Mov<Own<ast::FunctionalConstraint>> > (that.value);
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.copy< Mov<Own<ast::FunctorDeclaration>> > (that.value);
        break;

      case symbol_kind::S_pragma: // pragma
        value.copy< Mov<Own<ast::Pragma>> > (that.value);
        break;

      case symbol_kind::S_type_decl: // type_decl
        value.copy< Mov<Own<ast::Type>> > (that.value);
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.copy< Mov<RuleBody> > (that.value);
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.copy< Mov<VecOwn<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_head: // head
        value.copy< Mov<VecOwn<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.copy< Mov<VecOwn<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_adt_branch_list: // adt_branch_list
        value.copy< Mov<VecOwn<ast::BranchType>> > (that.value);
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.copy< Mov<VecOwn<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.copy< Mov<VecOwn<ast::Directive>> > (that.value);
        break;

      case symbol_kind::S_dependency_list_aux: // dependency_list_aux
      case symbol_kind::S_dependency_list: // dependency_list
        value.copy< Mov<VecOwn<ast::FunctionalConstraint>> > (that.value);
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_relation_names: // relation_names
        value.copy< Mov<VecOwn<ast::Relation>> > (that.value);
        break;

      case symbol_kind::S_non_empty_plan_order_list: // non_empty_plan_order_list
        value.copy< Mov<ast::ExecutionOrder::ExecOrder> > (that.value);
        break;

      case symbol_kind::S_qualified_name: // qualified_name
        value.copy< Mov<ast::QualifiedName> > (that.value);
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.copy< Mov<std::string> > (that.value);
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_component_type_params: // component_type_params
      case symbol_kind::S_component_param_list: // component_param_list
        value.copy< Mov<std::vector<ast::QualifiedName>> > (that.value);
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.copy< Mov<std::vector<std::pair
            <std::string, std::string>>> > (that.value);
        break;

      case symbol_kind::S_non_empty_attribute_names: // non_empty_attribute_names
        value.copy< Mov<std::vector<std::string>> > (that.value);
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.copy< ast::DirectiveType > (that.value);
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.copy< std::set<RelationTag> > (that.value);
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.move< AggregateOp > (that.value);
        break;

      case symbol_kind::S_arg: // arg
        value.move< Mov<Own<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_atom: // atom
        value.move< Mov<Own<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
      case symbol_kind::S_functor_attribute: // functor_attribute
        value.move< Mov<Own<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_adt_branch: // adt_branch
        value.move< Mov<Own<ast::BranchType>> > (that.value);
        break;

      case symbol_kind::S_fact: // fact
        value.move< Mov<Own<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_component_decl: // component_decl
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.move< Mov<Own<ast::Component>> > (that.value);
        break;

      case symbol_kind::S_component_init: // component_init
        value.move< Mov<Own<ast::ComponentInit>> > (that.value);
        break;

      case symbol_kind::S_component_type: // component_type
        value.move< Mov<Own<ast::ComponentType>> > (that.value);
        break;

      case symbol_kind::S_constraint: // constraint
        value.move< Mov<Own<ast::Constraint>> > (that.value);
        break;

      case symbol_kind::S_plan_order: // plan_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (that.value);
        break;

      case symbol_kind::S_query_plan: // query_plan
      case symbol_kind::S_query_plan_list: // query_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (that.value);
        break;

      case symbol_kind::S_dependency: // dependency
        value.move< Mov<Own<ast::FunctionalConstraint>> > (that.value);
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (that.value);
        break;

      case symbol_kind::S_pragma: // pragma
        value.move< Mov<Own<ast::Pragma>> > (that.value);
        break;

      case symbol_kind::S_type_decl: // type_decl
        value.move< Mov<Own<ast::Type>> > (that.value);
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.move< Mov<RuleBody> > (that.value);
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_head: // head
        value.move< Mov<VecOwn<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.move< Mov<VecOwn<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_adt_branch_list: // adt_branch_list
        value.move< Mov<VecOwn<ast::BranchType>> > (that.value);
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (that.value);
        break;

      case symbol_kind::S_dependency_list_aux: // dependency_list_aux
      case symbol_kind::S_dependency_list: // dependency_list
        value.move< Mov<VecOwn<ast::FunctionalConstraint>> > (that.value);
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_relation_names: // relation_names
        value.move< Mov<VecOwn<ast::Relation>> > (that.value);
        break;

      case symbol_kind::S_non_empty_plan_order_list: // non_empty_plan_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (that.value);
        break;

      case symbol_kind::S_qualified_name: // qualified_name
        value.move< Mov<ast::QualifiedName> > (that.value);
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.move< Mov<std::string> > (that.value);
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_component_type_params: // component_type_params
      case symbol_kind::S_component_param_list: // component_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (that.value);
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (that.value);
        break;

      case symbol_kind::S_non_empty_attribute_names: // non_empty_attribute_names
        value.move< Mov<std::vector<std::string>> > (that.value);
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.move< ast::DirectiveType > (that.value);
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.move< std::set<RelationTag> > (that.value);
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        yylhs.value.emplace< AggregateOp > ();
        break;

      case symbol_kind::S_arg: // arg
        yylhs.value.emplace< Mov<Own<ast::Argument>> > ();
        break;

      case symbol_kind::S_atom: // atom
        yylhs.value.emplace< Mov<Own<ast::Atom>> > ();
        break;

      case symbol_kind::S_attribute: // attribute
      case symbol_kind::S_functor_attribute: // functor_attribute
        yylhs.value.emplace< Mov<Own<ast::Attribute>> > ();
        break;

      case symbol_kind::S_adt_branch: // adt_branch
        yylhs.value.emplace< Mov<Own<ast::BranchType>> > ();
        break;

      case symbol_kind::S_fact: // fact
        yylhs.value.emplace< Mov<Own<ast::Clause>> > ();
        break;

      case symbol_kind::S_component_decl: // component_decl
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        yylhs.value.emplace< Mov<Own<ast::Component>> > ();
        break;

      case symbol_kind::S_component_init: // component_init
        yylhs.value.emplace< Mov<Own<ast::ComponentInit>> > ();
        break;

      case symbol_kind::S_component_type: // component_type
        yylhs.value.emplace< Mov<Own<ast::ComponentType>> > ();
        break;

      case symbol_kind::S_constraint: // constraint
        yylhs.value.emplace< Mov<Own<ast::Constraint>> > ();
        break;

      case symbol_kind::S_plan_order: // plan_order
        yylhs.value.emplace< Mov<Own<ast::ExecutionOrder>> > ();
        break;

      case symbol_kind::S_query_plan: // query_plan
      case symbol_kind::S_query_plan_list: // query_plan_list
        yylhs.value.emplace< Mov<Own<ast::ExecutionPlan>> > ();
        break;

      case symbol_kind::S_dependency: // dependency
        yylhs.value.emplace< Mov<Own<ast::FunctionalConstraint>> > ();
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        yylhs.value.emplace< Mov<Own<ast::FunctorDeclaration>> > ();
        break;

      case symbol_kind::S_pragma: // pragma
        yylhs.value.emplace< Mov<Own<ast::Pragma>> > ();
        break;

      case symbol_kind::S_type_decl: // type_decl
        yylhs.value.emplace< Mov<Own<ast::Type>> > ();
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        yylhs.value.emplace< Mov<RuleBody> > ();
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        yylhs.value.emplace< Mov<VecOwn<ast::Argument>> > ();
        break;

      case symbol_kind::S_head: // head
        yylhs.value.emplace< Mov<VecOwn<ast::Atom>> > ();
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        yylhs.value.emplace< Mov<VecOwn<ast::Attribute>> > ();
        break;

      case symbol_kind::S_adt_branch_list: // adt_branch_list
        yylhs.value.emplace< Mov<VecOwn<ast::BranchType>> > ();
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        yylhs.value.emplace< Mov<VecOwn<ast::Clause>> > ();
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        yylhs.value.emplace< Mov<VecOwn<ast::Directive>> > ();
        break;

      case symbol_kind::S_dependency_list_aux: // dependency_list_aux
      case symbol_kind::S_dependency_list: // dependency_list
        yylhs.value.emplace< Mov<VecOwn<ast::FunctionalConstraint>> > ();
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_relation_names: // relation_names
        yylhs.value.emplace< Mov<VecOwn<ast::Relation>> > ();
        break;

      case symbol_kind::S_non_empty_plan_order_list: // non_empty_plan_order_list
        yylhs.value.emplace< Mov<ast::ExecutionOrder::ExecOrder> > ();
        break;

      case symbol_kind::S_qualified_name: // qualified_name
        yylhs.value.emplace< Mov<ast::QualifiedName> > ();
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        yylhs.value.emplace< Mov<std::string> > ();
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_component_type_params: // component_type_params
      case symbol_kind::S_component_param_list: // component_param_list
        yylhs.value.emplace< Mov<std::vector<ast::QualifiedName>> > ();
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        yylhs.value.emplace< Mov<std::vector<std::pair
            <std::string, std::string>>> > ();
        break;

      case symbol_kind::S_non_empty_attribute_names: // non_empty_attribute_names
        yylhs.value.emplace< Mov<std::vector<std::string>> > ();
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        yylhs.value.emplace< ast::DirectiveType > ();
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        yylhs.value.emplace< std::set<RelationTag> > ();
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 3: // unit: %empty
#line 314 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    { }
#line 1349 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 4: // unit: unit directive_head
#line 316 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      for (auto&& cur : yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ())
        driver.addDirective(std::move(cur));
    }
#line 1358 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 5: // unit: unit rule
#line 321 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      for (auto&& cur : yystack_[0].value.as < Mov<VecOwn<ast::Clause>> > ()   )
        driver.addClause(std::move(cur));
    }
#line 1367 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 6: // unit: unit fact
#line 326 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      driver.addClause(yystack_[0].value.as < Mov<Own<ast::Clause>> > ());
    }
#line 1375 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 7: // unit: unit component_decl
#line 330 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      driver.addComponent(yystack_[0].value.as < Mov<Own<ast::Component>> > ());
    }
#line 1383 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 8: // unit: unit component_init
#line 334 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      driver.addInstantiation(yystack_[0].value.as < Mov<Own<ast::ComponentInit>> > ());
    }
#line 1391 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 9: // unit: unit pragma
#line 338 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      driver.addPragma(yystack_[0].value.as < Mov<Own<ast::Pragma>> > ());
    }
#line 1399 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 10: // unit: unit type_decl
#line 342 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      driver.addType(yystack_[0].value.as < Mov<Own<ast::Type>> > ());
    }
#line 1407 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 11: // unit: unit functor_decl
#line 346 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      driver.addFunctorDeclaration(yystack_[0].value.as < Mov<Own<ast::FunctorDeclaration>> > ());
    }
#line 1415 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 12: // unit: unit relation_decl
#line 350 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      for (auto&& rel : yystack_[0].value.as < Mov<VecOwn<ast::Relation>> > ()) {
        driver.addIoFromDeprecatedTag(*rel);
        driver.addRelation(std::move(rel));
      }
    }
#line 1426 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 13: // qualified_name: "identifier"
#line 364 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<ast::QualifiedName> > () = yystack_[0].value.as < std::string > ();
    }
#line 1434 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 14: // qualified_name: qualified_name "." "identifier"
#line 368 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<ast::QualifiedName> > () = yystack_[2].value.as < Mov<ast::QualifiedName> > (); yylhs.value.as < Mov<ast::QualifiedName> > ()->append(yystack_[0].value.as < std::string > ());
    }
#line 1442 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 15: // type_decl: "type declaration" "identifier" "<:" qualified_name
#line 378 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::SubsetType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<ast::QualifiedName> > (), yylhs.location);
    }
#line 1450 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 16: // type_decl: "type declaration" "identifier" "=" union_type_list
#line 382 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      if (yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > ().size() > 1) {
         yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::UnionType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > (), yylhs.location);
      } else {
         assert(yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > ().size() == 1 && "qualified name missing for alias type");
         yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::AliasType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > ()[0], yylhs.location);
      }
    }
#line 1463 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 17: // type_decl: "type declaration" "identifier" "=" record_type_list
#line 391 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::RecordType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<VecOwn<ast::Attribute>> > (), yylhs.location);
    }
#line 1471 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 18: // type_decl: "type declaration" "identifier" "=" adt_branch_list
#line 395 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::AlgebraicDataType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<VecOwn<ast::BranchType>> > (), yylhs.location);
    }
#line 1479 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 19: // type_decl: "numeric type declaration" "identifier"
#line 400 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as < std::string > (), "number", yylhs.location);
    }
#line 1487 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 20: // type_decl: "symbolic type declaration" "identifier"
#line 404 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as < std::string > (), "symbol", yylhs.location);
    }
#line 1495 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 21: // type_decl: "type declaration" "identifier"
#line 408 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as < std::string > (), "symbol", yylhs.location);
    }
#line 1503 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 22: // record_type_list: "[" "]"
#line 417 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    { }
#line 1509 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 23: // record_type_list: "[" non_empty_attributes "]"
#line 419 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > ();
    }
#line 1517 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 24: // union_type_list: qualified_name
#line 427 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < Mov<ast::QualifiedName> > ());
    }
#line 1525 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 25: // union_type_list: union_type_list "|" qualified_name
#line 431 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > () = yystack_[2].value.as < Mov<std::vector<ast::QualifiedName>> > ();
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < Mov<ast::QualifiedName> > ());
    }
#line 1534 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 26: // adt_branch_list: adt_branch
#line 439 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::BranchType>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::BranchType>> > ());
    }
#line 1542 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 27: // adt_branch_list: adt_branch_list "|" adt_branch
#line 443 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::BranchType>> > () = yystack_[2].value.as < Mov<VecOwn<ast::BranchType>> > ();
      yylhs.value.as < Mov<VecOwn<ast::BranchType>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::BranchType>> > ());
    }
#line 1551 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 28: // adt_branch: "identifier" "{" "}"
#line 451 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::BranchType>> > () = mk<ast::BranchType>(yystack_[2].value.as < std::string > (), VecOwn<ast::Attribute>{}, yylhs.location);
    }
#line 1559 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 29: // adt_branch: "identifier" "{" non_empty_attributes "}"
#line 455 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::BranchType>> > () = mk<ast::BranchType>(yystack_[3].value.as < std::string > (), yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > (), yylhs.location);
    }
#line 1567 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 30: // relation_decl: "relation declaration" relation_names attributes_list relation_tags dependency_list
#line 469 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto tags = yystack_[1].value.as < std::set<RelationTag> > ();
      auto attributes_list = yystack_[2].value.as < Mov<VecOwn<ast::Attribute>> > ();
      yylhs.value.as < Mov<VecOwn<ast::Relation>> > () = yystack_[3].value.as < Mov<VecOwn<ast::Relation>> > ();
      for (auto&& rel : yylhs.value.as < Mov<VecOwn<ast::Relation>> > ()) {
        for (auto tag : tags) {
          if (isRelationQualifierTag(tag)) {
            rel->addQualifier(getRelationQualifierFromTag(tag));
          } else if (isRelationRepresentationTag(tag)) {
            rel->setRepresentation(getRelationRepresentationFromTag(tag));
          } else {
            assert(false && "unhandled tag");
          }
        }
        for (auto&& fd : yystack_[0].value.as < Mov<VecOwn<ast::FunctionalConstraint>> > ()) {
          rel->addDependency(souffle::clone(fd));
        }
        rel->setAttributes(clone(attributes_list));
      }
    }
#line 1592 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 31: // relation_names: "identifier"
#line 496 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Relation>> > ().push_back(mk<ast::Relation>(yystack_[0].value.as < std::string > (), yystack_[0].location));
    }
#line 1600 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 32: // relation_names: relation_names "," "identifier"
#line 500 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Relation>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Relation>> > ();
      yylhs.value.as < Mov<VecOwn<ast::Relation>> > ().push_back(mk<ast::Relation>(yystack_[0].value.as < std::string > (), yystack_[0].location));
    }
#line 1609 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 33: // attributes_list: "(" ")"
#line 511 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
    }
#line 1616 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 34: // attributes_list: "(" non_empty_attributes ")"
#line 514 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > ();
    }
#line 1624 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 35: // non_empty_attributes: attribute
#line 521 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Attribute>> > ());
    }
#line 1632 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 36: // non_empty_attributes: non_empty_attributes "," attribute
#line 525 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Attribute>> > ();
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Attribute>> > ());
    }
#line 1641 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 37: // attribute: "identifier" ":" qualified_name
#line 533 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Attribute>> > () = mk<ast::Attribute>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location);
    }
#line 1649 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 38: // relation_tags: %empty
#line 543 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    { }
#line 1655 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 39: // relation_tags: relation_tags "relation qualifier overidable"
#line 545 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::OVERRIDABLE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1663 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 40: // relation_tags: relation_tags "relation qualifier inline"
#line 549 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::INLINE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1671 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 41: // relation_tags: relation_tags "relation qualifier no_inline"
#line 553 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::NO_INLINE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1679 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 42: // relation_tags: relation_tags "relation qualifier magic"
#line 557 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::MAGIC, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1687 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 43: // relation_tags: relation_tags "relation qualifier no_magic"
#line 561 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::NO_MAGIC, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1695 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 44: // relation_tags: relation_tags "BRIE datastructure qualifier"
#line 565 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::BRIE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1703 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 45: // relation_tags: relation_tags "BTREE datastructure qualifier"
#line 569 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::BTREE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1711 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 46: // relation_tags: relation_tags "BTREE_DELETE datastructure qualifier"
#line 573 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::BTREE_DELETE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1719 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 47: // relation_tags: relation_tags "equivalence relation qualifier"
#line 577 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::EQREL, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1727 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 48: // relation_tags: relation_tags "relation qualifier output"
#line 582 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::OUTPUT, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1735 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 49: // relation_tags: relation_tags "relation qualifier input"
#line 586 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::INPUT, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1743 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 50: // relation_tags: relation_tags "relation qualifier printsize"
#line 590 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::PRINTSIZE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ());
    }
#line 1751 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 51: // non_empty_attribute_names: "identifier"
#line 600 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<std::string>> > ().push_back(yystack_[0].value.as < std::string > ());
    }
#line 1759 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 52: // non_empty_attribute_names: non_empty_attribute_names "," "identifier"
#line 605 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<std::string>> > () = yystack_[2].value.as < Mov<std::vector<std::string>> > ();
      yylhs.value.as < Mov<std::vector<std::string>> > ().push_back(yystack_[0].value.as < std::string > ());
    }
#line 1768 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 53: // dependency: "identifier"
#line 616 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
        yylhs.value.as < Mov<Own<ast::FunctionalConstraint>> > () = mk<ast::FunctionalConstraint>(mk<ast::Variable>(yystack_[0].value.as < std::string > (), yylhs.location), yylhs.location);
    }
#line 1776 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 54: // dependency: "(" non_empty_attribute_names ")"
#line 620 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      VecOwn<ast::Variable> keys;
      for (std::string s : yystack_[1].value.as < Mov<std::vector<std::string>> > ()) {
        keys.push_back(mk<ast::Variable>(s, yylhs.location));
      }
      yylhs.value.as < Mov<Own<ast::FunctionalConstraint>> > () = mk<ast::FunctionalConstraint>(std::move(keys), yylhs.location);
    }
#line 1788 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 55: // dependency_list_aux: dependency
#line 631 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::FunctionalConstraint>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::FunctionalConstraint>> > ());
    }
#line 1796 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 56: // dependency_list_aux: dependency_list_aux "," dependency
#line 635 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::FunctionalConstraint>> > () = std::move(yystack_[2].value.as < Mov<VecOwn<ast::FunctionalConstraint>> > ());
      yylhs.value.as < Mov<VecOwn<ast::FunctionalConstraint>> > ().push_back(std::move(yystack_[0].value.as < Mov<Own<ast::FunctionalConstraint>> > ()));
    }
#line 1805 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 57: // dependency_list: %empty
#line 643 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    { }
#line 1811 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 58: // dependency_list: "choice-domain" dependency_list_aux
#line 645 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::FunctionalConstraint>> > () = std::move(yystack_[0].value.as < Mov<VecOwn<ast::FunctionalConstraint>> > ());
    }
#line 1819 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 59: // fact: atom "."
#line 659 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Clause>> > () = mk<ast::Clause>(yystack_[1].value.as < Mov<Own<ast::Atom>> > (), Mov<VecOwn<ast::Literal>> {}, nullptr, yylhs.location);
    }
#line 1827 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 60: // rule: rule_def
#line 669 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Clause>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Clause>> > ();
    }
#line 1835 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 61: // rule: rule_def query_plan
#line 673 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Clause>> > () = yystack_[1].value.as < Mov<VecOwn<ast::Clause>> > ();
      auto query_plan = yystack_[0].value.as < Mov<Own<ast::ExecutionPlan>> > ();
      for (auto&& rule : yylhs.value.as < Mov<VecOwn<ast::Clause>> > ()) {
        rule->setExecutionPlan(clone(query_plan));
      }
    }
#line 1847 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 62: // rule: atom "<=" atom ":-" body "."
#line 681 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto bodies = yystack_[1].value.as < Mov<RuleBody> > ()->toClauseBodies();
      Own<ast::Atom> lt = nameUnnamedVariables(std::move(yystack_[5].value.as < Mov<Own<ast::Atom>> > ()));
      Own<ast::Atom> gt = std::move(yystack_[3].value.as < Mov<Own<ast::Atom>> > ());
      for (auto&& body : bodies) {
        auto cur = mk<ast::SubsumptiveClause>(clone(lt)); 
        cur->setBodyLiterals(clone(body->getBodyLiterals()));
        auto literals = cur->getBodyLiterals();
        cur->setHead(clone(lt));
        cur->addToBodyFront(clone(gt));
        cur->addToBodyFront(clone(lt));
        cur->setSrcLoc(yylhs.location);
        yylhs.value.as < Mov<VecOwn<ast::Clause>> > ().push_back(std::move(cur));
      }
    }
#line 1867 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 63: // rule: atom "<=" atom ":-" body "." query_plan
#line 697 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto bodies = yystack_[2].value.as < Mov<RuleBody> > ()->toClauseBodies();
      Own<ast::Atom> lt = nameUnnamedVariables(std::move(yystack_[6].value.as < Mov<Own<ast::Atom>> > ()));
      Own<ast::Atom> gt = std::move(yystack_[4].value.as < Mov<Own<ast::Atom>> > ());
      for (auto&& body : bodies) {
        auto cur = mk<ast::SubsumptiveClause>(clone(lt)); 
        cur->setBodyLiterals(clone(body->getBodyLiterals()));
        auto literals = cur->getBodyLiterals();
        cur->setHead(clone(lt));
        cur->addToBodyFront(clone(gt));
        cur->addToBodyFront(clone(lt));
        cur->setSrcLoc(yylhs.location);
        cur->setExecutionPlan(clone(yystack_[0].value.as < Mov<Own<ast::ExecutionPlan>> > ()));
        yylhs.value.as < Mov<VecOwn<ast::Clause>> > ().push_back(std::move(cur));
      }
    }
#line 1888 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 64: // rule_def: head ":-" body "."
#line 720 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto bodies = yystack_[1].value.as < Mov<RuleBody> > ()->toClauseBodies();
      for (auto&& head : yystack_[3].value.as < Mov<VecOwn<ast::Atom>> > ()) {
        for (auto&& body : bodies) {
          auto cur = clone(body);
          cur->setHead(clone(head));
          cur->setSrcLoc(yylhs.location);
          yylhs.value.as < Mov<VecOwn<ast::Clause>> > ().push_back(std::move(cur));
        }
      }
    }
#line 1904 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 65: // head: atom
#line 738 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Atom>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Atom>> > ());
    }
#line 1912 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 66: // head: head "," atom
#line 742 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Atom>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Atom>> > (); yylhs.value.as < Mov<VecOwn<ast::Atom>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Atom>> > ());
    }
#line 1920 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 67: // body: disjunction
#line 752 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > ();
    }
#line 1928 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 68: // disjunction: conjunction
#line 759 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > ();
    }
#line 1936 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 69: // disjunction: disjunction ";" conjunction
#line 763 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[2].value.as < Mov<RuleBody> > ();
      yylhs.value.as < Mov<RuleBody> > ()->disjunct(yystack_[0].value.as < Mov<RuleBody> > ());
    }
#line 1945 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 70: // conjunction: term
#line 771 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > ();
    }
#line 1953 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 71: // conjunction: conjunction "," term
#line 775 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[2].value.as < Mov<RuleBody> > ();
      yylhs.value.as < Mov<RuleBody> > ()->conjunct(yystack_[0].value.as < Mov<RuleBody> > ());
    }
#line 1962 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 72: // term: atom
#line 786 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = RuleBody::atom(yystack_[0].value.as < Mov<Own<ast::Atom>> > ());
    }
#line 1970 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 73: // term: constraint
#line 790 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = RuleBody::constraint(yystack_[0].value.as < Mov<Own<ast::Constraint>> > ());
    }
#line 1978 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 74: // term: "(" disjunction ")"
#line 794 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[1].value.as < Mov<RuleBody> > ();
    }
#line 1986 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 75: // term: "!" term
#line 798 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > ()->negated();
    }
#line 1994 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 76: // atom: qualified_name "(" arg_list ")"
#line 808 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Atom>> > () = mk<ast::Atom>(yystack_[3].value.as < Mov<ast::QualifiedName> > (), yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location);
    }
#line 2002 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 77: // constraint: arg "<" arg
#line 819 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::LT, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2010 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 78: // constraint: arg ">" arg
#line 823 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::GT, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2018 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 79: // constraint: arg "<=" arg
#line 827 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::LE, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2026 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 80: // constraint: arg ">=" arg
#line 831 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::GE, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2034 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 81: // constraint: arg "=" arg
#line 835 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::EQ, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2042 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 82: // constraint: arg "!=" arg
#line 839 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::NE, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2050 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 83: // constraint: "match predicate" "(" arg "," arg ")"
#line 845 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::MATCH, yystack_[3].value.as < Mov<Own<ast::Argument>> > (), yystack_[1].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2058 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 84: // constraint: "checks whether substring is contained in a string" "(" arg "," arg ")"
#line 849 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
       yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::CONTAINS, yystack_[3].value.as < Mov<Own<ast::Argument>> > (), yystack_[1].value.as < Mov<Own<ast::Argument>> > (), yylhs.location);
    }
#line 2066 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 85: // constraint: "true literal constraint"
#line 855 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BooleanConstraint>(true , yylhs.location);
    }
#line 2074 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 86: // constraint: "false literal constraint"
#line 859 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BooleanConstraint>(false, yylhs.location);
    }
#line 2082 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 87: // arg_list: %empty
#line 869 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
    }
#line 2089 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 88: // arg_list: non_empty_arg_list
#line 872 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Argument>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Argument>> > ();
    }
#line 2097 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 89: // non_empty_arg_list: arg
#line 878 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Argument>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2105 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 90: // non_empty_arg_list: non_empty_arg_list "," arg
#line 882 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Argument>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > (); yylhs.value.as < Mov<VecOwn<ast::Argument>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2113 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 91: // arg: "symbol"
#line 893 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::StringConstant>(yystack_[0].value.as < std::string > (), yylhs.location);
    }
#line 2121 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 92: // arg: "float"
#line 897 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(yystack_[0].value.as < std::string > (), ast::NumericConstant::Type::Float, yylhs.location);
    }
#line 2129 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 93: // arg: "unsigned number"
#line 901 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto&& n = yystack_[0].value.as < std::string > (); // drop the last character (`u`)
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(n.substr(0, n.size() - 1), ast::NumericConstant::Type::Uint, yylhs.location);
    }
#line 2138 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 94: // arg: "number"
#line 906 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(yystack_[0].value.as < std::string > (), yylhs.location);
    }
#line 2146 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 95: // arg: "_"
#line 910 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UnnamedVariable>(yylhs.location);
    }
#line 2154 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 96: // arg: "$"
#line 914 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = driver.addDeprecatedCounter(yylhs.location);
    }
#line 2162 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 97: // arg: "auto-increment functor" "(" ")"
#line 918 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::Counter>(yylhs.location);
    }
#line 2170 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 98: // arg: "identifier"
#line 922 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::Variable>(yystack_[0].value.as < std::string > (), yylhs.location);
    }
#line 2178 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 99: // arg: "nil reference"
#line 926 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NilConstant>(yylhs.location);
    }
#line 2186 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 100: // arg: "[" arg_list "]"
#line 930 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::RecordInit>(yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location);
    }
#line 2194 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 101: // arg: "$" qualified_name "(" arg_list ")"
#line 934 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::BranchInit>(yystack_[3].value.as < Mov<ast::QualifiedName> > (), yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location);
    }
#line 2202 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 102: // arg: "(" arg ")"
#line 938 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = yystack_[1].value.as < Mov<Own<ast::Argument>> > ();
    }
#line 2210 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 103: // arg: "type cast" "(" arg "," qualified_name ")"
#line 942 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::TypeCast>(yystack_[3].value.as < Mov<Own<ast::Argument>> > (), yystack_[1].value.as < Mov<ast::QualifiedName> > (), yylhs.location);
    }
#line 2218 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 104: // arg: "@" "identifier" "(" arg_list ")"
#line 946 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UserDefinedFunctor>(yystack_[3].value.as < std::string > (), *yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location);
    }
#line 2226 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 105: // arg: functor_built_in "(" arg_list ")"
#line 950 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yystack_[3].value.as < Mov<std::string> > (), *yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location);
    }
#line 2234 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 106: // arg: aggregate_func "(" arg "," non_empty_arg_list ")"
#line 956 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      VecOwn<ast::Argument> arg_list = yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > ();
      arg_list.insert(arg_list.begin(), yystack_[3].value.as < Mov<Own<ast::Argument>> > ());
      auto agg_2_func = [](AggregateOp op) -> char const* {
        switch (op) {
          case AggregateOp::COUNT : return {};
          case AggregateOp::MAX   : return "max";
          case AggregateOp::MEAN  : return {};
          case AggregateOp::MIN   : return "min";
          case AggregateOp::SUM   : return {};
          default                 :
            fatal("missing base op handler, or got an overload op?");
        }
      };
      if (auto* func_op = agg_2_func(yystack_[5].value.as < AggregateOp > ())) {
        yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(func_op, std::move(arg_list), yylhs.location);
      } else {
        driver.error(yylhs.location, "aggregate operation has no functor equivalent");
        yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UnnamedVariable>(yylhs.location);
      }
    }
#line 2260 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 107: // arg: "-" arg
#line 981 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      // If we have a constant that is not already negated we just negate the constant value.
      auto nested_arg = *yystack_[0].value.as < Mov<Own<ast::Argument>> > ();
      const auto* asNumeric = as<ast::NumericConstant>(*nested_arg);
      if (asNumeric && !isPrefix("-", asNumeric->getConstant())) {
        yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>("-" + asNumeric->getConstant(), asNumeric->getFixedType(), yystack_[0].location);
      } else { // Otherwise, create a functor.
        yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, FUNCTOR_INTRINSIC_PREFIX_NEGATE_NAME, std::move(nested_arg));
      }
    }
#line 2275 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 108: // arg: "bnot" arg
#line 992 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "~", yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2283 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 109: // arg: "lnot" arg
#line 996 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "!", yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2291 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 110: // arg: arg "+" arg
#line 1002 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "+"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2299 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 111: // arg: arg "-" arg
#line 1006 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "-"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2307 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 112: // arg: arg "*" arg
#line 1010 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "*"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2315 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 113: // arg: arg "/" arg
#line 1014 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "/"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2323 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 114: // arg: arg "%" arg
#line 1018 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "%"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2331 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 115: // arg: arg "^" arg
#line 1022 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "**" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2339 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 116: // arg: arg "land" arg
#line 1026 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "&&" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2347 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 117: // arg: arg "lor" arg
#line 1030 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "||" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2355 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 118: // arg: arg "lxor" arg
#line 1034 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "^^" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2363 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 119: // arg: arg "band" arg
#line 1038 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "&"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2371 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 120: // arg: arg "bor" arg
#line 1042 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "|"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2379 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 121: // arg: arg "bxor" arg
#line 1046 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "^"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2387 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 122: // arg: arg "bshl" arg
#line 1050 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "<<" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2395 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 123: // arg: arg "bshr" arg
#line 1054 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, ">>" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2403 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 124: // arg: arg "bshru" arg
#line 1058 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, ">>>", yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ());
    }
#line 2411 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 125: // arg: "@" "@" "identifier" arg_list ":" arg "," aggregate_body
#line 1063 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto bodies = yystack_[0].value.as < Mov<RuleBody> > ()->toClauseBodies();
      if (bodies.size() != 1) {
        driver.error("ERROR: disjunctions in aggregation clauses are currently not supported");
      }
      auto expr = yystack_[4].value.as < Mov<VecOwn<ast::Argument>> > ().empty() ? nullptr : std::move(yystack_[4].value.as < Mov<VecOwn<ast::Argument>> > ()[0]);
      auto body = (bodies.size() == 1) ? clone(bodies[0]->getBodyLiterals()) : VecOwn<ast::Literal> {};
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UserDefinedAggregator>(yystack_[5].value.as < std::string > (), std::move(yystack_[2].value.as < Mov<Own<ast::Argument>> > ()), std::move(expr), std::move(body), yylhs.location);
    }
#line 2425 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 126: // arg: aggregate_func arg_list ":" aggregate_body
#line 1074 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto bodies = yystack_[0].value.as < Mov<RuleBody> > ()->toClauseBodies();
      if (bodies.size() != 1) {
        driver.error("ERROR: disjunctions in aggregation clauses are currently not supported");
      }
      // TODO: move this to a semantic check when aggs are extended to multiple exprs
      auto given    = yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > ().size();
      auto required = aggregateArity(yystack_[3].value.as < AggregateOp > ());
      if (given < required.first || required.second < given) {
        driver.error("ERROR: incorrect expression arity for given aggregate mode");
      }
      auto expr = yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > ().empty() ? nullptr : std::move(yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > ()[0]);
      auto body = (bodies.size() == 1) ? clone(bodies[0]->getBodyLiterals()) : VecOwn<ast::Literal> {};
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicAggregator>(yystack_[3].value.as < AggregateOp > (), std::move(expr), std::move(body), yylhs.location);
    }
#line 2445 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 127: // functor_built_in: "concatenation of strings"
#line 1093 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "cat";
    }
#line 2453 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 128: // functor_built_in: "ordinal number of a string"
#line 1097 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "ord";
    }
#line 2461 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 129: // functor_built_in: "range"
#line 1101 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "range";
    }
#line 2469 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 130: // functor_built_in: "length of a string"
#line 1105 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "strlen";
    }
#line 2477 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 131: // functor_built_in: "sub-string of a string"
#line 1109 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "substr";
    }
#line 2485 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 132: // functor_built_in: "convert to float"
#line 1113 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "to_float";
    }
#line 2493 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 133: // functor_built_in: "convert to signed integer"
#line 1117 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "to_number";
    }
#line 2501 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 134: // functor_built_in: "convert to string"
#line 1121 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "to_string";
    }
#line 2509 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 135: // functor_built_in: "convert to unsigned integer"
#line 1125 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "to_unsigned";
    }
#line 2517 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 136: // aggregate_func: "count aggregator"
#line 1132 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < AggregateOp > () = AggregateOp::COUNT;
    }
#line 2525 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 137: // aggregate_func: "max aggregator"
#line 1136 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < AggregateOp > () = AggregateOp::MAX;
    }
#line 2533 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 138: // aggregate_func: "mean aggregator"
#line 1140 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < AggregateOp > () = AggregateOp::MEAN;
    }
#line 2541 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 139: // aggregate_func: "min aggregator"
#line 1144 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < AggregateOp > () = AggregateOp::MIN;
    }
#line 2549 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 140: // aggregate_func: "sum aggregator"
#line 1148 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < AggregateOp > () = AggregateOp::SUM;
    }
#line 2557 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 141: // aggregate_body: "{" body "}"
#line 1155 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = yystack_[1].value.as < Mov<RuleBody> > ();
    }
#line 2565 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 142: // aggregate_body: atom
#line 1159 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<RuleBody> > () = RuleBody::atom(yystack_[0].value.as < Mov<Own<ast::Atom>> > ());
    }
#line 2573 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 143: // query_plan: "plan keyword" query_plan_list
#line 1169 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > () = yystack_[0].value.as < Mov<Own<ast::ExecutionPlan>> > ();
    }
#line 2581 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 144: // query_plan_list: "number" ":" plan_order
#line 1175 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > () = mk<ast::ExecutionPlan>();
      yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > ()->setOrderFor(RamSignedFromString(yystack_[2].value.as < std::string > ()), Own<ast::ExecutionOrder>(yystack_[0].value.as < Mov<Own<ast::ExecutionOrder>> > ()));
    }
#line 2590 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 145: // query_plan_list: query_plan_list "," "number" ":" plan_order
#line 1180 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > () = yystack_[4].value.as < Mov<Own<ast::ExecutionPlan>> > ();
      yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > ()->setOrderFor(RamSignedFromString(yystack_[2].value.as < std::string > ()), yystack_[0].value.as < Mov<Own<ast::ExecutionOrder>> > ());
    }
#line 2599 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 146: // plan_order: "(" ")"
#line 1188 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ExecutionOrder>> > () = mk<ast::ExecutionOrder>(ast::ExecutionOrder::ExecOrder(), yylhs.location);
    }
#line 2607 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 147: // plan_order: "(" non_empty_plan_order_list ")"
#line 1192 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ExecutionOrder>> > () = mk<ast::ExecutionOrder>(yystack_[1].value.as < Mov<ast::ExecutionOrder::ExecOrder> > (), yylhs.location);
    }
#line 2615 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 148: // non_empty_plan_order_list: "number"
#line 1199 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<ast::ExecutionOrder::ExecOrder> > ().push_back(RamUnsignedFromString(yystack_[0].value.as < std::string > ()));
    }
#line 2623 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 149: // non_empty_plan_order_list: non_empty_plan_order_list "," "number"
#line 1203 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<ast::ExecutionOrder::ExecOrder> > () = yystack_[2].value.as < Mov<ast::ExecutionOrder::ExecOrder> > (); yylhs.value.as < Mov<ast::ExecutionOrder::ExecOrder> > ().push_back(RamUnsignedFromString(yystack_[0].value.as < std::string > ()));
    }
#line 2631 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 150: // component_decl: component_head "{" component_body "}"
#line 1217 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto head = yystack_[3].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->setComponentType(clone(head->getComponentType()));
      yylhs.value.as < Mov<Own<ast::Component>> > ()->copyBaseComponents(**head);
      yylhs.value.as < Mov<Own<ast::Component>> > ()->setSrcLoc(yylhs.location);
    }
#line 2643 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 151: // component_head: "component declaration" component_type
#line 1231 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = mk<ast::Component>();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->setComponentType(yystack_[0].value.as < Mov<Own<ast::ComponentType>> > ());
    }
#line 2652 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 152: // component_head: component_head ":" component_type
#line 1236 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[2].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addBaseComponent(yystack_[0].value.as < Mov<Own<ast::ComponentType>> > ());
    }
#line 2661 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 153: // component_head: component_head "," component_type
#line 1241 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[2].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addBaseComponent(yystack_[0].value.as < Mov<Own<ast::ComponentType>> > ());
    }
#line 2670 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 154: // component_type: "identifier" component_type_params
#line 1252 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ComponentType>> > () = mk<ast::ComponentType>(yystack_[1].value.as < std::string > (), yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > (), yylhs.location);
    }
#line 2678 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 155: // component_type_params: %empty
#line 1261 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    { }
#line 2684 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 156: // component_type_params: "<" component_param_list ">"
#line 1263 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > () = yystack_[1].value.as < Mov<std::vector<ast::QualifiedName>> > ();
    }
#line 2692 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 157: // component_param_list: "identifier"
#line 1273 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < std::string > ());
    }
#line 2700 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 158: // component_param_list: component_param_list "," "identifier"
#line 1277 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > () = yystack_[2].value.as < Mov<std::vector<ast::QualifiedName>> > ();
      yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < std::string > ());
    }
#line 2709 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 159: // component_body: %empty
#line 1288 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = mk<ast::Component>();
    }
#line 2717 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 160: // component_body: component_body directive_head
#line 1292 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      for (auto&& x : yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ()) {
        yylhs.value.as < Mov<Own<ast::Component>> > ()->addDirective(std::move(x));
      }
    }
#line 2728 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 161: // component_body: component_body rule
#line 1299 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      for (auto&& x : yystack_[0].value.as < Mov<VecOwn<ast::Clause>> > ()) {
        yylhs.value.as < Mov<Own<ast::Component>> > ()->addClause(std::move(x));
      }
    }
#line 2739 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 162: // component_body: component_body fact
#line 1306 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addClause(yystack_[0].value.as < Mov<Own<ast::Clause>> > ());
    }
#line 2748 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 163: // component_body: component_body "override rules of super-component" "identifier"
#line 1311 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[2].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addOverride(yystack_[0].value.as < std::string > ());
    }
#line 2757 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 164: // component_body: component_body component_init
#line 1316 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addInstantiation(yystack_[0].value.as < Mov<Own<ast::ComponentInit>> > ());
    }
#line 2766 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 165: // component_body: component_body component_decl
#line 1321 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addComponent(yystack_[0].value.as < Mov<Own<ast::Component>> > ());
    }
#line 2775 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 166: // component_body: component_body type_decl
#line 1326 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      yylhs.value.as < Mov<Own<ast::Component>> > ()->addType(yystack_[0].value.as < Mov<Own<ast::Type>> > ());
    }
#line 2784 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 167: // component_body: component_body relation_decl
#line 1331 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
      for (auto&& rel : yystack_[0].value.as < Mov<VecOwn<ast::Relation>> > ()) {
        driver.addIoFromDeprecatedTag(*rel);
        yylhs.value.as < Mov<Own<ast::Component>> > ()->addRelation(std::move(rel));
      }
    }
#line 2796 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 168: // component_init: "component instantiation" "identifier" "=" component_type
#line 1345 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::ComponentInit>> > () = mk<ast::ComponentInit>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<Own<ast::ComponentType>> > (), yylhs.location);
    }
#line 2804 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 169: // functor_decl: "functor declaration" "identifier" "(" functor_arg_type_list ")" ":" qualified_name
#line 1359 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::FunctorDeclaration>> > () = mk<ast::FunctorDeclaration>(yystack_[5].value.as < std::string > (), yystack_[3].value.as < Mov<VecOwn<ast::Attribute>> > (), mk<ast::Attribute>("return_type", yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location), false, yylhs.location);
    }
#line 2812 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 170: // functor_decl: "functor declaration" "identifier" "(" functor_arg_type_list ")" ":" qualified_name "stateful functor"
#line 1363 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::FunctorDeclaration>> > () = mk<ast::FunctorDeclaration>(yystack_[6].value.as < std::string > (), yystack_[4].value.as < Mov<VecOwn<ast::Attribute>> > (), mk<ast::Attribute>("return_type", yystack_[1].value.as < Mov<ast::QualifiedName> > (), yystack_[1].location), true, yylhs.location);
    }
#line 2820 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 171: // functor_arg_type_list: %empty
#line 1372 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
           { }
#line 2826 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 172: // functor_arg_type_list: non_empty_functor_arg_type_list
#line 1374 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Attribute>> > ();
    }
#line 2834 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 173: // non_empty_functor_arg_type_list: functor_attribute
#line 1381 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Attribute>> > ());
    }
#line 2842 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 174: // non_empty_functor_arg_type_list: non_empty_functor_arg_type_list "," functor_attribute
#line 1385 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Attribute>> > (); yylhs.value.as < Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Attribute>> > ());
    }
#line 2850 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 175: // functor_attribute: qualified_name
#line 1392 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Attribute>> > () = mk<ast::Attribute>("", yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location);
    }
#line 2858 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 176: // functor_attribute: "identifier" ":" qualified_name
#line 1396 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Attribute>> > () = mk<ast::Attribute>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location);
    }
#line 2866 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 177: // pragma: "pragma directive" "symbol" "symbol"
#line 1410 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Pragma>> > () = mk<ast::Pragma>(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > (), yylhs.location);
    }
#line 2874 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 178: // pragma: "pragma directive" "symbol"
#line 1414 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<Own<ast::Pragma>> > () = mk<ast::Pragma>(yystack_[0].value.as < std::string > (), "", yylhs.location);
    }
#line 2882 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 179: // directive_head: directive_head_decl directive_list
#line 1424 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      auto directive_head_decl = yystack_[1].value.as < ast::DirectiveType > ();
      for (auto&& io : yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ()) {
        io->setType(directive_head_decl);
        yylhs.value.as < Mov<VecOwn<ast::Directive>> > ().push_back(std::move(io));
      }
    }
#line 2894 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 180: // directive_head_decl: "input directives declaration"
#line 1435 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::input;
    }
#line 2902 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 181: // directive_head_decl: "output directives declaration"
#line 1439 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::output;
    }
#line 2910 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 182: // directive_head_decl: "printsize directives declaration"
#line 1443 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::printsize;
    }
#line 2918 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 183: // directive_head_decl: "limitsize directives declaration"
#line 1447 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::limitsize;
    }
#line 2926 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 184: // directive_list: relation_directive_list
#line 1457 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ();
    }
#line 2934 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 185: // directive_list: relation_directive_list "(" ")"
#line 1461 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Directive>> > ();
    }
#line 2942 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 186: // directive_list: relation_directive_list "(" non_empty_key_value_pairs ")"
#line 1465 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[3].value.as < Mov<VecOwn<ast::Directive>> > ();
      for (auto&& kvp : yystack_[1].value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ()) {
        for (auto&& io : yylhs.value.as < Mov<VecOwn<ast::Directive>> > ()) {
          io->addParameter(kvp.first, kvp.second);
        }
      }
    }
#line 2956 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 187: // relation_directive_list: qualified_name
#line 1480 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Directive>> > ().push_back(mk<ast::Directive>(ast::DirectiveType::input, yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location));
    }
#line 2964 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 188: // relation_directive_list: relation_directive_list "," qualified_name
#line 1484 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Directive>> > ();
      yylhs.value.as < Mov<VecOwn<ast::Directive>> > ().push_back(mk<ast::Directive>(ast::DirectiveType::input, yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location));
    }
#line 2973 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 189: // non_empty_key_value_pairs: "identifier" "=" kvp_value
#line 1495 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ().push_back({yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::string> > ()});
    }
#line 2982 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 190: // non_empty_key_value_pairs: non_empty_key_value_pairs "," "identifier" "=" kvp_value
#line 1499 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > () = yystack_[4].value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ();
      yylhs.value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ().push_back({yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::string> > ()});
    }
#line 2994 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 191: // kvp_value: "symbol"
#line 1507 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = yystack_[0].value.as < std::string > ();
    }
#line 3002 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 192: // kvp_value: "identifier"
#line 1511 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = yystack_[0].value.as < std::string > ();
    }
#line 3010 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 193: // kvp_value: "number"
#line 1515 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = yystack_[0].value.as < std::string > ();
    }
#line 3018 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 194: // kvp_value: "true literal constraint"
#line 1519 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "true";
    }
#line 3026 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;

  case 195: // kvp_value: "false literal constraint"
#line 1523 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"
    {
      yylhs.value.as < Mov<std::string> > () = "false";
    }
#line 3034 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"
    break;


#line 3038 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -192;

  const signed char parser::yytable_ninf_ = -14;

  const short
  parser::yypact_[] =
  {
    -192,    25,   249,  -192,  -192,    56,    72,    77,  -192,  -192,
    -192,  -192,   101,   114,   133,   140,   155,    66,  -192,  -192,
    -192,  -192,    -9,   -26,     6,  -192,    22,  -192,  -192,  -192,
    -192,   169,   105,  -192,   -32,   103,   -64,    90,  -192,   115,
    -192,  -192,   277,   193,   218,  -192,   176,   169,  -192,   169,
     114,   114,  -192,   146,  -192,   -31,  -192,     3,   220,  -192,
     222,    13,   169,   223,  -192,   114,  -192,  -192,  -192,  -192,
    -192,   159,  -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,
    -192,  -192,  -192,  -192,  -192,  -192,   160,    11,  -192,   277,
    -192,   169,   277,   277,   277,   277,   161,   162,   684,   163,
     330,  -192,   158,   166,    67,   170,   173,  -192,  -192,   176,
     176,   171,   174,   179,  -192,  -192,  -192,   387,  -192,   212,
    -192,  -192,    20,     4,   169,   183,  -192,   139,  -192,  -192,
     151,   184,   146,   181,   186,  -192,   177,     8,   146,  -192,
     198,   201,  -192,   146,  -192,   -53,  -192,   194,   277,   196,
     263,   203,    68,   190,   453,   190,   190,  -192,   277,   277,
     277,   277,   277,   277,   277,   277,   277,   277,   277,   277,
     277,   277,   277,   277,   277,   277,   200,   204,   269,   277,
     277,  -192,    14,   354,  -192,   176,   176,   277,   277,   277,
     277,   277,   277,   176,   274,  -192,  -192,  -192,  -192,  -192,
    -192,  -192,  -192,   206,  -192,   141,   146,   169,  -192,   283,
    -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,
    -192,  -192,     7,  -192,   169,   219,   222,     0,  -192,    24,
     169,   297,   308,  -192,  -192,   486,   277,   277,  -192,   277,
    -192,   684,   109,   109,   190,   190,   190,   190,   -44,   756,
     334,   104,   104,   104,   750,   717,    19,   239,   420,     2,
       9,  -192,   238,   519,   552,  -192,   179,  -192,   684,   684,
     684,   684,   684,   684,   236,  -192,    15,  -192,   312,   146,
    -192,  -192,   313,  -192,   243,   146,   169,  -192,  -192,   -40,
    -192,   146,   177,  -192,  -192,   169,   245,   244,   247,  -192,
     277,   176,  -192,  -192,  -192,  -192,   143,   204,   277,   277,
      -9,  -192,  -192,  -192,  -192,  -192,  -192,   242,  -192,   145,
       7,     5,  -192,    30,  -192,   277,  -192,   147,   237,  -192,
     319,  -192,   585,   618,  -192,    15,  -192,   321,  -192,  -192,
    -192,   651,  -192,  -192,  -192,  -192,  -192,  -192,  -192,     2,
    -192
  };

  const unsigned char
  parser::yydefact_[] =
  {
       3,     0,     2,     1,    13,     0,     0,     0,   180,   181,
     182,   183,     0,     0,     0,     0,     0,     0,    10,    12,
       6,     5,    60,     0,    65,     7,     0,     8,    11,     9,
       4,     0,   178,    31,     0,     0,    21,   155,   151,     0,
      19,    20,    87,     0,     0,    61,     0,     0,    59,     0,
       0,     0,   159,   187,   179,   184,   177,     0,     0,    38,
     171,     0,     0,     0,   154,     0,    91,    98,    94,    93,
      92,     0,   127,   128,   129,   130,   131,   138,   139,   137,
     136,   140,   132,   133,   134,   135,     0,     0,    99,    87,
      95,    96,     0,     0,     0,     0,     0,    88,    89,     0,
      87,    14,     0,   143,    98,     0,     0,    85,    86,     0,
       0,     0,    67,    68,    70,    72,    73,     0,    66,     0,
     153,   152,     0,     0,     0,     0,    33,     0,    35,    32,
      57,    13,   175,     0,   172,   173,    13,     0,    24,    17,
      16,    18,    26,    15,   157,     0,   168,     0,     0,     0,
       0,     0,     0,   107,     0,   108,   109,    76,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    87,     0,     0,     0,     0,     0,
       0,    75,     0,     0,    64,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   166,   167,   162,   161,
     165,   164,   160,     0,   185,     0,   188,     0,    34,     0,
      48,    49,    50,    44,    45,    46,    47,    39,    40,    41,
      42,    43,     0,    30,     0,     0,     0,     0,    22,     0,
       0,     0,     0,   156,    97,     0,    87,    87,   100,    87,
     102,    90,   110,   111,   112,   113,   115,   114,   119,   120,
     121,   122,   123,   124,   116,   117,   118,     0,     0,     0,
       0,   144,     0,     0,     0,    74,    69,    71,    81,    77,
      78,    79,    80,    82,     0,   163,     0,   186,     0,    37,
      36,    53,     0,    55,    58,   176,     0,   174,    28,     0,
      23,    25,     0,    27,   158,     0,     0,     0,     0,   105,
       0,     0,   142,   126,   148,   146,     0,     0,     0,     0,
      62,   191,   192,   193,   194,   195,   189,     0,    51,     0,
       0,   169,    29,     0,   104,     0,   101,     0,     0,   147,
       0,   145,     0,     0,    63,     0,    54,     0,    56,   170,
     103,     0,   106,   141,   149,    83,    84,   190,    52,     0,
     125
  };

  const short
  parser::yypgoto_[] =
  {
    -192,  -192,  -192,   -30,   205,  -192,  -192,  -192,    95,   227,
    -192,  -192,  -134,   119,  -192,  -192,    31,  -192,  -192,   230,
     231,  -192,  -192,  -191,   232,   180,  -104,    -2,  -192,   -79,
      44,   -37,  -192,  -192,    17,    57,  -192,    47,  -192,   246,
    -192,   -17,  -192,  -192,  -192,   248,  -192,  -192,  -192,   148,
    -192,   250,  -192,  -192,  -192,  -192,    34
  };

  const short
  parser::yydefgoto_[] =
  {
       0,     1,     2,    17,    18,   139,   140,   141,   142,    19,
      34,    59,   127,   128,   130,   319,   283,   284,   223,    20,
      21,    22,    23,   111,   112,   113,   114,   115,   116,    96,
      97,    98,    99,   100,   303,    45,   103,   261,   306,    25,
      26,    38,    64,   145,   122,    27,    28,   133,   134,   135,
      29,    30,    31,    54,    55,   205,   316
  };

  const short
  parser::yytable_[] =
  {
      24,    53,   274,   229,   125,   181,     4,   125,   203,   117,
     151,   281,   125,    46,   304,   149,    61,   136,   311,   312,
     313,   176,   232,    62,     4,     3,   159,   160,    44,   339,
     132,   138,   143,   120,   121,   209,   233,   161,   162,   163,
     164,    57,   123,    58,   124,   118,   322,   119,   146,    47,
     314,   315,   168,   169,   170,   153,   154,   155,   156,    32,
       6,   152,     8,     9,    10,    11,   194,    12,    13,    14,
      15,    16,   117,   183,   150,   228,    33,   126,   204,   137,
     282,    35,   267,   305,    43,    48,   288,   301,   265,   159,
     160,   290,   185,   289,   206,   257,    49,    50,    51,   209,
     161,   162,   163,   164,   340,    36,   195,    52,    56,    43,
     328,   235,   165,   166,   167,   168,   169,   170,    37,   171,
      24,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    39,   258,    42,
     -13,   239,   263,   264,    40,    43,   -13,    43,   117,   117,
     268,   269,   270,   271,   272,   273,   117,   296,   297,    41,
     298,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,     4,   159,   160,    60,   279,    63,    66,
     104,    68,    69,    70,    71,   161,   162,   163,   164,   222,
     161,   162,   163,   164,   285,    65,   132,   101,   105,   106,
     291,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,   107,   108,   208,   209,   277,   278,   329,   330,   336,
     337,   342,   158,   102,   129,    43,   131,   144,    82,    83,
      84,    85,   147,   148,   177,   157,   174,   158,    86,    87,
      88,   178,    89,   179,    90,    91,   180,    92,   109,   110,
     184,   193,   185,     4,   186,   225,   321,   302,     5,   207,
     224,   226,   227,   230,   117,   323,   231,   237,   234,   236,
     238,   332,   333,   163,   262,    94,   259,   260,   275,    95,
      66,    67,    68,    69,    70,    71,   276,   125,   341,     6,
       7,     8,     9,    10,    11,   286,    12,    13,    14,    15,
      16,   292,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,   294,   299,   307,   310,   317,   318,   320,   324,
     325,   326,   335,   343,   344,   348,   293,   196,   280,    82,
      83,    84,    85,    66,    67,    68,    69,    70,    71,    86,
      87,    88,   182,    89,   327,    90,    91,   302,    92,   197,
      93,   338,   198,   199,   331,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,   266,   350,   334,   200,   347,
     201,     0,   202,     0,   287,     0,    94,     0,     0,     0,
      95,     0,    82,    83,    84,    85,     0,     0,     0,     0,
       0,     0,    86,    87,    88,     0,    89,     0,    90,    91,
       0,    92,     0,   175,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,   162,   163,   164,     0,
       0,     0,     0,     0,   159,   160,     0,   165,   240,    94,
     168,   169,   170,    95,   187,   161,   162,   163,   164,     0,
       0,     0,   188,   189,   190,   191,   192,   165,   166,   167,
     168,   169,   170,     0,   171,   172,   173,   159,   160,     0,
       0,     0,     0,     0,     0,     0,     0,   187,   161,   162,
     163,   164,     0,     0,     0,   188,   189,   190,   191,   192,
     165,   166,   167,   168,   169,   170,     0,   171,   172,   173,
     159,   160,     0,     0,   240,   300,     0,     0,     0,     0,
       0,   161,   162,   163,   164,     0,     0,     0,     0,     0,
       0,     0,     0,   165,   166,   167,   168,   169,   170,     0,
     171,   172,   173,   159,   160,     0,     0,   240,     0,     0,
       0,     0,     0,     0,   161,   162,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,   165,   166,   167,   168,
     169,   170,     0,   171,   172,   173,   159,   160,     0,     0,
       0,   295,     0,     0,     0,     0,     0,   161,   162,   163,
     164,     0,     0,     0,     0,     0,     0,     0,     0,   165,
     166,   167,   168,   169,   170,     0,   171,   172,   173,   159,
     160,     0,     0,     0,   308,     0,     0,     0,     0,     0,
     161,   162,   163,   164,     0,     0,     0,     0,     0,     0,
       0,     0,   165,   166,   167,   168,   169,   170,     0,   171,
     172,   173,   159,   160,     0,     0,     0,   309,     0,     0,
       0,     0,     0,   161,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,   165,   166,   167,   168,   169,
     170,     0,   171,   172,   173,   159,   160,     0,     0,   345,
       0,     0,     0,     0,     0,     0,   161,   162,   163,   164,
       0,     0,     0,     0,     0,     0,     0,     0,   165,   166,
     167,   168,   169,   170,     0,   171,   172,   173,   159,   160,
       0,     0,   346,     0,     0,     0,     0,     0,     0,   161,
     162,   163,   164,     0,     0,     0,     0,     0,     0,     0,
       0,   165,   166,   167,   168,   169,   170,     0,   171,   172,
     173,   159,   160,     0,     0,     0,   349,     0,     0,     0,
       0,     0,   161,   162,   163,   164,     0,     0,     0,     0,
       0,     0,     0,     0,   165,   166,   167,   168,   169,   170,
       0,   171,   172,   173,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,   162,   163,   164,     0,
       0,     0,     0,     0,     0,     0,     0,   165,   166,   167,
     168,   169,   170,     0,   171,   172,   173,   159,   160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   161,   162,
     163,   164,     0,     0,     0,     0,     0,     0,     0,     0,
     165,   166,   167,   168,   169,   170,     0,   171,     0,   173,
     159,   160,     0,     0,     0,     0,   159,   160,     0,     0,
       0,   161,   162,   163,   164,     0,     0,   161,   162,   163,
     164,     0,     0,   165,   166,   167,   168,   169,   170,   165,
       0,   167,   168,   169,   170
  };

  const short
  parser::yycheck_[] =
  {
       2,    31,   193,   137,     4,   109,     4,     4,     4,    46,
      89,     4,     4,    39,     5,     4,    80,     4,     3,     4,
       5,   100,    75,    87,     4,     0,    70,    71,    37,    24,
      60,    61,    62,    50,    51,    75,    89,    81,    82,    83,
      84,    73,    73,    75,    75,    47,    86,    49,    65,    75,
      35,    36,    96,    97,    98,    92,    93,    94,    95,     3,
      40,    91,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,   109,   110,    63,    67,     4,    74,    74,    66,
      73,     4,   186,    74,    79,    79,    86,    85,    74,    70,
      71,    67,    78,   227,   124,   174,    90,    75,    76,    75,
      81,    82,    83,    84,    74,     4,    86,    85,     3,    79,
     301,   148,    93,    94,    95,    96,    97,    98,     4,   100,
     122,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,     4,   175,    73,
      73,    73,   179,   180,     4,    79,    79,    79,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   236,   237,     4,
     239,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,     4,    70,    71,    73,   207,    88,     3,
       4,     5,     6,     7,     8,    81,    82,    83,    84,    38,
      81,    82,    83,    84,   224,    80,   226,     4,    22,    23,
     230,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    74,    75,    74,    75,    74,    75,    74,
      75,    74,    75,     5,     4,    79,     4,     4,    52,    53,
      54,    55,    73,    73,    76,    74,    73,    75,    62,    63,
      64,    75,    66,    73,    68,    69,    73,    71,    72,    73,
      79,    39,    78,     4,    75,    74,   286,   259,     9,    76,
      76,    75,    85,    65,   301,   295,    65,     4,    74,    73,
      67,   308,   309,    83,     5,    99,    76,    73,     4,   103,
       3,     4,     5,     6,     7,     8,    80,     4,   325,    40,
      41,    42,    43,    44,    45,    76,    47,    48,    49,    50,
      51,     4,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,     4,    74,    76,    79,     4,     4,    75,    74,
      76,    74,    80,    86,     5,     4,   231,   122,   209,    52,
      53,    54,    55,     3,     4,     5,     6,     7,     8,    62,
      63,    64,   110,    66,   300,    68,    69,   349,    71,   122,
      73,   320,   122,   122,   307,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,   185,   349,   310,   122,   335,
     122,    -1,   122,    -1,   226,    -1,    99,    -1,    -1,    -1,
     103,    -1,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    64,    -1,    66,    -1,    68,    69,
      -1,    71,    -1,    73,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,    -1,
      -1,    -1,    -1,    -1,    70,    71,    -1,    93,    74,    99,
      96,    97,    98,   103,    80,    81,    82,    83,    84,    -1,
      -1,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    81,    82,
      83,    84,    -1,    -1,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      70,    71,    -1,    -1,    74,    75,    -1,    -1,    -1,    -1,
      -1,    81,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    70,    71,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    82,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    70,    71,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    70,
      71,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    70,    71,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    70,    71,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    70,    71,
      -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    70,    71,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    82,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,
      83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,    -1,   102,
      70,    71,    -1,    -1,    -1,    -1,    70,    71,    -1,    -1,
      -1,    81,    82,    83,    84,    -1,    -1,    81,    82,    83,
      84,    -1,    -1,    93,    94,    95,    96,    97,    98,    93,
      -1,    95,    96,    97,    98
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,   107,   108,     0,     4,     9,    40,    41,    42,    43,
      44,    45,    47,    48,    49,    50,    51,   109,   110,   115,
     125,   126,   127,   128,   133,   145,   146,   151,   152,   156,
     157,   158,     3,     4,   116,     4,     4,     4,   147,     4,
       4,     4,    73,    79,    37,   141,    39,    75,    79,    90,
      75,    76,    85,   109,   159,   160,     3,    73,    75,   117,
      73,    80,    87,    88,   148,    80,     3,     4,     5,     6,
       7,     8,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    52,    53,    54,    55,    62,    63,    64,    66,
      68,    69,    71,    73,    99,   103,   135,   136,   137,   138,
     139,     4,     5,   142,     4,    22,    23,    35,    36,    72,
      73,   129,   130,   131,   132,   133,   134,   137,   133,   133,
     147,   147,   150,    73,    75,     4,    74,   118,   119,     4,
     120,     4,   109,   153,   154,   155,     4,    66,   109,   111,
     112,   113,   114,   109,     4,   149,   147,    73,    73,     4,
      63,   135,   109,   137,   137,   137,   137,    74,    75,    70,
      71,    81,    82,    83,    84,    93,    94,    95,    96,    97,
      98,   100,   101,   102,    73,    73,   135,    76,    75,    73,
      73,   132,   130,   137,    79,    78,    75,    80,    88,    89,
      90,    91,    92,    39,    46,    86,   110,   115,   125,   126,
     145,   151,   157,     4,    74,   161,   109,    76,    74,    75,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    38,   124,    76,    74,    75,    85,    67,   118,
      65,    65,    75,    89,    74,   137,    73,     4,    67,    73,
      74,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   135,   137,    76,
      73,   143,     5,   137,   137,    74,   131,   132,   137,   137,
     137,   137,   137,   137,   129,     4,    80,    74,    75,   109,
     119,     4,    73,   122,   123,   109,    76,   155,    86,   118,
      67,   109,     4,   114,     4,    75,   135,   135,   135,    74,
      75,    85,   133,   140,     5,    74,   144,    76,    75,    75,
      79,     3,     4,     5,    35,    36,   162,     4,     4,   121,
      75,   109,    86,   109,    74,    76,    74,   136,   129,    74,
      75,   143,   137,   137,   141,    80,    74,    75,   122,    24,
      74,   137,    74,    86,     5,    74,    74,   162,     4,    75,
     140
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,   106,   107,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   109,   109,   110,   110,   110,   110,   110,
     110,   110,   111,   111,   112,   112,   113,   113,   114,   114,
     115,   116,   116,   117,   117,   118,   118,   119,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   121,   121,   122,   122,   123,   123,   124,   124,   125,
     126,   126,   126,   126,   127,   128,   128,   129,   130,   130,
     131,   131,   132,   132,   132,   132,   133,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   135,   135,   136,
     136,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   139,   139,   139,   139,
     139,   140,   140,   141,   142,   142,   143,   143,   144,   144,
     145,   146,   146,   146,   147,   148,   148,   149,   149,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   151,   152,
     152,   153,   153,   154,   154,   155,   155,   156,   156,   157,
     158,   158,   158,   158,   159,   159,   159,   160,   160,   161,
     161,   162,   162,   162,   162,   162
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     3,     4,     4,     4,     4,     2,
       2,     2,     2,     3,     1,     3,     1,     3,     3,     4,
       5,     1,     3,     2,     3,     1,     3,     3,     0,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     3,     1,     3,     1,     3,     0,     2,     2,
       1,     2,     6,     7,     4,     1,     3,     1,     1,     3,
       1,     3,     1,     1,     3,     2,     4,     3,     3,     3,
       3,     3,     3,     6,     6,     1,     1,     0,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       3,     5,     3,     6,     5,     4,     6,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     8,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     3,     5,     2,     3,     1,     3,
       4,     2,     3,     3,     2,     0,     3,     1,     3,     0,
       2,     2,     2,     3,     2,     2,     2,     2,     4,     7,
       8,     0,     1,     1,     3,     1,     3,     3,     2,     2,
       1,     1,     1,     1,     1,     3,     4,     1,     3,     3,
       5,     1,     1,     1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\"symbol\"",
  "\"identifier\"", "\"number\"", "\"unsigned number\"", "\"float\"",
  "\"auto-increment functor\"", "\"pragma directive\"",
  "\"relation qualifier output\"", "\"relation qualifier input\"",
  "\"relation qualifier printsize\"", "\"BRIE datastructure qualifier\"",
  "\"BTREE datastructure qualifier\"",
  "\"BTREE_DELETE datastructure qualifier\"",
  "\"equivalence relation qualifier\"",
  "\"relation qualifier overidable\"", "\"relation qualifier inline\"",
  "\"relation qualifier no_inline\"", "\"relation qualifier magic\"",
  "\"relation qualifier no_magic\"", "\"match predicate\"",
  "\"checks whether substring is contained in a string\"",
  "\"stateful functor\"", "\"concatenation of strings\"",
  "\"ordinal number of a string\"", "\"range\"", "\"length of a string\"",
  "\"sub-string of a string\"", "\"mean aggregator\"",
  "\"min aggregator\"", "\"max aggregator\"", "\"count aggregator\"",
  "\"sum aggregator\"", "\"true literal constraint\"",
  "\"false literal constraint\"", "\"plan keyword\"", "\"choice-domain\"",
  "\":-\"", "\"relation declaration\"", "\"functor declaration\"",
  "\"input directives declaration\"", "\"output directives declaration\"",
  "\"printsize directives declaration\"",
  "\"limitsize directives declaration\"",
  "\"override rules of super-component\"", "\"type declaration\"",
  "\"component declaration\"", "\"component instantiation\"",
  "\"numeric type declaration\"", "\"symbolic type declaration\"",
  "\"convert to float\"", "\"convert to signed integer\"",
  "\"convert to string\"", "\"convert to unsigned integer\"",
  "\"convert int to unsigned\"", "\"convert int to float\"",
  "\"convert unsigned to int\"", "\"convert unsigned to float\"",
  "\"convert float to int\"", "\"convert float to unsigned\"",
  "\"type cast\"", "\"@\"", "\"nil reference\"", "\"|\"", "\"[\"", "\"]\"",
  "\"_\"", "\"$\"", "\"+\"", "\"-\"", "\"!\"", "\"(\"", "\")\"", "\",\"",
  "\":\"", "\"::\"", "\";\"", "\".\"", "\"=\"", "\"*\"", "\"/\"", "\"^\"",
  "\"%\"", "\"{\"", "\"}\"", "\"<:\"", "\"<\"", "\">\"", "\"<=\"",
  "\">=\"", "\"!=\"", "\"band\"", "\"bor\"", "\"bxor\"", "\"bshl\"",
  "\"bshr\"", "\"bshru\"", "\"bnot\"", "\"land\"", "\"lor\"", "\"lxor\"",
  "\"lnot\"", "\"fold\"", "NEG", "$accept", "program", "unit",
  "qualified_name", "type_decl", "record_type_list", "union_type_list",
  "adt_branch_list", "adt_branch", "relation_decl", "relation_names",
  "attributes_list", "non_empty_attributes", "attribute", "relation_tags",
  "non_empty_attribute_names", "dependency", "dependency_list_aux",
  "dependency_list", "fact", "rule", "rule_def", "head", "body",
  "disjunction", "conjunction", "term", "atom", "constraint", "arg_list",
  "non_empty_arg_list", "arg", "functor_built_in", "aggregate_func",
  "aggregate_body", "query_plan", "query_plan_list", "plan_order",
  "non_empty_plan_order_list", "component_decl", "component_head",
  "component_type", "component_type_params", "component_param_list",
  "component_body", "component_init", "functor_decl",
  "functor_arg_type_list", "non_empty_functor_arg_type_list",
  "functor_attribute", "pragma", "directive_head", "directive_head_decl",
  "directive_list", "relation_directive_list", "non_empty_key_value_pairs",
  "kvp_value", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   306,   306,   313,   315,   320,   325,   329,   333,   337,
     341,   345,   349,   363,   367,   377,   381,   390,   394,   399,
     403,   407,   416,   418,   426,   430,   438,   442,   450,   454,
     468,   495,   499,   510,   513,   520,   524,   532,   542,   544,
     548,   552,   556,   560,   564,   568,   572,   576,   581,   585,
     589,   599,   604,   615,   619,   630,   634,   642,   644,   658,
     668,   672,   680,   696,   719,   737,   741,   751,   758,   762,
     770,   774,   785,   789,   793,   797,   807,   818,   822,   826,
     830,   834,   838,   844,   848,   854,   858,   868,   871,   877,
     881,   892,   896,   900,   905,   909,   913,   917,   921,   925,
     929,   933,   937,   941,   945,   949,   955,   980,   991,   995,
    1001,  1005,  1009,  1013,  1017,  1021,  1025,  1029,  1033,  1037,
    1041,  1045,  1049,  1053,  1057,  1062,  1073,  1092,  1096,  1100,
    1104,  1108,  1112,  1116,  1120,  1124,  1131,  1135,  1139,  1143,
    1147,  1154,  1158,  1168,  1174,  1179,  1187,  1191,  1198,  1202,
    1216,  1230,  1235,  1240,  1251,  1260,  1262,  1272,  1276,  1287,
    1291,  1298,  1305,  1310,  1315,  1320,  1325,  1330,  1344,  1358,
    1362,  1372,  1373,  1380,  1384,  1391,  1395,  1409,  1413,  1423,
    1434,  1438,  1442,  1446,  1456,  1460,  1464,  1479,  1483,  1494,
    1498,  1506,  1510,  1514,  1518,  1522
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


} // yy
#line 3889 "/builddir/build/BUILD/souffle-2.4/redhat-linux-build/src/parser/parser.cc"

#line 1528 "/builddir/build/BUILD/souffle-2.4/src/parser/parser.yy"


void yy::parser::error(const location_type &l, const std::string &m)
{
  driver.error(l, m);
}
